_data segment public 'Data'
	assume CS:_data,DS:_data

	org 100h

CPUID	macro
	DB 0fh,0a2h
	endm

start: call If_CPUID_present
	jz print_mmx_absent
.386
	mov	eax,1
	CPUID
	and	edx,1 shl 23
	jz	print_mmx_absent
.8086

print_mmx_preset:
	lea	dx,msgpresent
	mov	ah,9
	int	21h
	jmp	quit

print_mmx_absent:
	lea	dx,msgabsent
	mov	ah,9
	int	21h

quit:
	mov	ax,4c00h
	int	21h

.386

if_cpuid_present proc near
	cli
	pushfd
	pop	eax
	mov	ebx,eax
	xor	eax,200000h
	push	eax
	popfd
	pushfd
	pop	eax
	push	ebx
	popfd
	sti
	xor	eax,ebx
	ret
if_cpuid_present endp

	msgabsent	db 'MMX ',0dh,0ah,'$'
	msgpresent	db 'MMX ',0dh,0ah,'$'
_data	ends
	end start	